import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsMpPages, CmsMpPagesParam } from './model';


/**
 * 分页查询小程序页面
 */
export async function pageCmsMpPages(params: CmsMpPagesParam) {
  const res = await request.get<ApiResult<PageResult<CmsMpPages>>>(
    '/cms/cms-mp-pages/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询小程序页面列表
 */
export async function listCmsMpPages(params?: CmsMpPagesParam) {
  const res = await request.get<ApiResult<CmsMpPages[]>>(
    '/cms/cms-mp-pages',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加小程序页面
 */
export async function addCmsMpPages(data: CmsMpPages) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-mp-pages',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改小程序页面
 */
export async function updateCmsMpPages(data: CmsMpPages) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-mp-pages',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除小程序页面
 */
export async function removeCmsMpPages(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-mp-pages/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除小程序页面
 */
export async function removeBatchCmsMpPages(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-mp-pages/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询小程序页面
 */
export async function getCmsMpPages(id: number) {
  const res = await request.get<ApiResult<CmsMpPages>>(
    '/cms/cms-mp-pages/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
